> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List columns for all elements in a workbook

GET https://api.sigmacomputing.com/v2/workbooks/{workbookId}/columns

This endpoint retrieves all columns in a workbook for all element in the workbook.

  ### Usage notes
  - Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.

  ### Usage scenarios
  - **Data exploration:** Enable users to explore the data structure of a workbook element, facilitating deeper analysis and understanding.
  - **Integration tasks:** Useful for developers integrating Sigma with other tools that need to know the data structure to map data accurately.

  ### Best practices
  - Use this endpoint when setting up interfaces that require specific knowledge about the data structure.

Reference: https://help.sigmacomputing.com/reference/get-workbook-columns

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/workbooks/{workbookId}/columns:
    get:
      operationId: getWorkbookColumns
      summary: List columns for all elements in a workbook
      description: >-
        This endpoint retrieves all columns in a workbook for all element in the
        workbook.

          ### Usage notes
          - Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.

          ### Usage scenarios
          - **Data exploration:** Enable users to explore the data structure of a workbook element, facilitating deeper analysis and understanding.
          - **Integration tasks:** Useful for developers integrating Sigma with other tools that need to know the data structure to map data accurately.

          ### Best practices
          - Use this endpoint when setting up interfaces that require specific knowledge about the data structure.
      tags:
        - Workbooks
      parameters:
        - name: workbookId
          in: path
          required: true
          schema:
            type: string
        - name: page
          in: query
          required: false
          schema:
            type: string
        - name: limit
          in: query
          required: false
          schema:
            type: number
            format: double
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/workbooks_getWorkbookColumns_Response_200'
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2WorkbooksWorkbookIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItemsType:
      type: object
      properties: {}
      description: The column's data type, represented as a recursive type object.
      title: >-
        V2WorkbooksWorkbookIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItemsType
    V2WorkbooksWorkbookIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItems:
      type: object
      properties:
        columnId:
          type: string
          description: Column ID
        name:
          type: string
          description: Column name
        formula:
          type: string
          description: Column formula or source column reference.
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItemsType
          description: The column's data type, represented as a recursive type object.
        elementId:
          type: string
          description: Element ID
      required:
        - columnId
        - name
        - formula
        - type
        - elementId
      title: >-
        V2WorkbooksWorkbookIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItems
    workbooks_getWorkbookColumns_Response_200:
      type: object
      properties:
        entries:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2WorkbooksWorkbookIdColumnsGetResponsesContentApplicationJsonSchemaEntriesItems
        nextPage:
          type:
            - string
            - 'null'
        total:
          type: number
          format: double
      required:
        - entries
        - nextPage
      title: workbooks_getWorkbookColumns_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Response**

```json
{
  "entries": [
    {
      "columnId": "cWoHPEQoiG",
      "name": "string",
      "formula": "[STATIONS/City]",
      "type": {},
      "elementId": "4eJb2QhzOm",
      "label": "City"
    },
    {
      "columnId": "RyThlKefu",
      "name": "string",
      "formula": "[STATIONS/Dock Count]",
      "type": {},
      "elementId": "4eJb2QhzOm",
      "label": "Dock Count"
    },
    {
      "columnId": "ffARyThlK",
      "name": "string",
      "formula": "[STATIONS/Name]",
      "type": {},
      "elementId": "4eJb2QhzOm",
      "label": "Name"
    }
  ],
  "nextPage": null
}
```

**SDK Code**

```python Response Example
import requests

url = "https://api.sigmacomputing.com/v2/workbooks/workbookId/columns"

headers = {"Authorization": "<token>."}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Response Example
const url = 'https://api.sigmacomputing.com/v2/workbooks/workbookId/columns';
const options = {method: 'GET', headers: {Authorization: '<token>.'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Response Example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks/workbookId/columns"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<token>.")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Response Example
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks/workbookId/columns")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'

response = http.request(request)
puts response.read_body
```

```java Response Example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/workbooks/workbookId/columns")
  .header("Authorization", "<token>.")
  .asString();
```

```php Response Example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/workbooks/workbookId/columns', [
  'headers' => [
    'Authorization' => '<token>.',
  ],
]);

echo $response->getBody();
```

```csharp Response Example
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks/workbookId/columns");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
IRestResponse response = client.Execute(request);
```

```swift Response Example
import Foundation

let headers = ["Authorization": "<token>."]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks/workbookId/columns")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```